#ifndef MACRO_H
#define MACRO_H

#include <stdio.h>

#define WRAP(s) do { s } while (0);

#undef MIN
#undef MAX
#undef MID
#define MIN(x,y)     (((x) < (y)) ? (x) : (y))
#define MAX(x,y)     (((x) > (y)) ? (x) : (y))
#define MID(x,y,z)   MAX((x), MIN((y), (z)))
// Those macros copied from Allegro rather than using them through bm.h

#define COL(y,cr,cb) (((y)*16+(cr)*4+(cb)-10)&255)
#define PAL0(n,c) bmPut8(BMVID_PALETTE0+n, c)
#define PAL1(n,c) bmPut8(BMVID_PALETTE1+n, c)

#define PT(b,x,y) b->d[b->w*(y)+(x)]

#define uchar unsigned char

#define Case break; case
#define Default break; default

#define fmgetw(f) (( fgetc(f)<<8) + fgetc(f))
#define fmgetl(f) ((fmgetw(f)<<16)+fmgetw(f))
#define fmputw(w,f) WRAP( fputc((w)>>8,f); fputc((w)&0xff,f);  )
#define fmputl(l,f) WRAP( fmputw((l)>>16,f); fmputw((l)&0xffff,f); )

extern FILE *fr; // trace write file

#endif

