#include "share.h"
#include <string.h>

#define TILE_X ((mouse_x*scale+OX)/TILE_SIZE)
#define TILE_Y ((mouse_y*scale+OY)/TILE_SIZE)

#define ADD_INSERTION(nn)              \
        if (CI==-1) {                  \
          CI=map.n_ins;                \
          map.i[CI].x=mouse_x*scale+OX;      \
          map.i[CI].y=mouse_y*scale+OY;      \
          map.i[CI].n=nn;              \
          map.n_ins++;                 \
        }                              \

  uchar CT=0; // current tile
  int CI=-1; // current_insertion
  int scale=1, selU,selD,selL,selR,selW,selH;
  int old_ox,old_oy;
  bool selON=false;
  uchar sel[MAX_MAP_X][MAX_MAP_Y];
bool maped_palette_view=false,maped_internal_view=false;

static void init()
{
  install_mouse();
  show_mouse(screen);

  gui_fg_color=211;
}

char sy[]="0+-PM";
char *ins_str[]={"Nothing","Player","Flag","Troll","Token","?","?"};

void in_bounds(int &xfrom,int &xto, int &yfrom,int &yto)
{
  if (xfrom<0) xfrom=0;
  if (yfrom<0) yfrom=0;
  if (maped_palette_view) {
    if (xto>15) xto=15;
    if (yto>7) yto=7;
  } else {
    if (xto>=map.w) xto=map.w-1;
    if (yto>=map.h) yto=map.h-1;
  }
}

void draw_all()
{
  int xfrom,xto,yfrom,yto,tx,ty;
  int w,h;
  char s1[80];
  uchar a;
  BITMAP *b;
  
  w=SCREEN_W; h=SCREEN_H;

  clear_to_color(buf,col_magenta);
  b=(BITMAP*)D[C0].dat;
  blit(b,buf,(TILE_SIZE*map.w-w) ? (b->w-w)*OX/(TILE_SIZE*map.w-w) :0,
             (TILE_SIZE*map.h-h) ? (b->h-h)*OY/(TILE_SIZE*map.h-h) :0,0,0,w,h);

  xfrom=OX/TILE_SIZE; xto=(OX+w*scale)/TILE_SIZE;
  yfrom=OY/TILE_SIZE; yto=(OY+h*scale)/TILE_SIZE;
  
  in_bounds(xfrom,xto,yfrom,yto);

  for (tx=xfrom; tx<=xto; tx++) {
    for (ty=yfrom; ty<=yto; ty++) {
      calc_tile(tx,ty);
      if (maped_palette_view) b=BT(tx+ty*16);
      else if (maped_internal_view) b=BT(map.a[tx][ty]);
      else b=BT(map.b[tx][ty]);

      if (scale==1)
        draw_sprite(buf, b, tx*TILE_SIZE-OX, ty*TILE_SIZE-OY);
      if (scale==2)
        stretch_sprite(buf, b, (tx*TILE_SIZE-OX)/2, (ty*TILE_SIZE-OY)/2, 16,16);
      if (scale==4)
        stretch_sprite(buf, b, (tx*TILE_SIZE-OX)/4, (ty*TILE_SIZE-OY)/4, 8,8);
      if (selON && tx>=selL && tx<=selR && (ty==selD || ty==selU)) {
        circlefill(buf,(tx*TILE_SIZE-OX+8)/scale,(ty*TILE_SIZE-OY+8)/scale,2+4/scale,col_green);
      }
      if (selON && (tx==selL || tx==selR) && ty<=selD && ty>=selU) {
        circlefill(buf,(tx*TILE_SIZE-OX+8)/scale,(ty*TILE_SIZE-OY+8)/scale,2+4/scale,col_magenta);
      }
    }
  }

#define X (map.i[tx].x-OX)/scale
#define Y (map.i[tx].y-OY)/scale
#define C(c) if (scale==1) { circlefill(buf,X,Y,5,c); circle(buf,X,Y,5,col_black); } \
             else if (scale==2) circlefill(buf,X,Y,3,c)

  for (tx=0;tx<map.n_ins;tx++) {
    switch(map.i[tx].n/10) {
      case 1: circlefill(buf,X,Y,5,col_green);
         if (scale==1) textprintf_ex(buf,font,X-4,Y-4,col_red,-1,"%d",map.i[tx].n%10);
      Case 2: C(col_white);
      Case 3: C(col_magenta);
      Case 4: C(col_cyan);
      Case 5: C(col_blue);
          if (scale==1) textprintf_ex(buf,font,X-4,Y-4,col_white,-1,"%c",sy[map.i[tx].n%10]); 
      Default: C(col_black);
    }
  }

#undef X
#undef Y
#undef C 

  rectfill(buf,0,0,SCREEN_W,SCREEN_H/10,col_black);

  if (CI==-1) {
    draw_sprite(buf, BT(CT), 1,1);
    a=tile_attr[CT];
    sprintf(s1,"Current tile: %d   Attributes: %s %s", CT,
        (a & ATTR_SOLID_TOP ? "Solid-top" : ""),
        (a & ATTR_SOLID_LRB ? "Solid-LRB" : ""));
  } else {
    int n=map.i[CI].n;
    sprintf(s1,"Insertion #%d of %d: %d (%s) at (%d,%d)",CI,map.n_ins,n,n<60 ? ins_str[n/10]:"-",
        map.i[CI].x,map.i[CI].y);
    // Here we want to put in some clue as to what it is
  }

  textprintf_ex(buf,font,37,10,col_white,-1, "%s, W=%d, H=%d",
      maped_palette_view ? "Tile palette view" :
      (maped_internal_view ? "Raw tile view" : "Normal view"), map.w,map.h);
  textout_ex(buf,font,s1,37,20,col_white,-1);

 // vsync();
  scare_mouse();
  blit(buf,screen,0,0,0,0,SCREEN_W,SCREEN_H);
  unscare_mouse();
}

bool mouse_in()
{
  return TILE_X>=0 && TILE_Y>=0 && TILE_X<map.w && TILE_Y<map.h;
}

void set_scale(int s)
{
  OX+=scale*SCREEN_W/2;
  OY+=scale*SCREEN_H/2;
  scale=s;
  OX-=scale*SCREEN_W/2;
  OY-=scale*SCREEN_H/2;
}

void maped_main(char *fn)
{
  int j,k,d,d1;
  char fn1[80];
  int xfrom,xto,yfrom,yto,tx,ty;

//  fprintf(fr,"Starting maped (%s)\n",fn);

  init();
  if (fn) {
    strcpy(fn1,fn);
    load_map(fn);
    CI=-1;
  }

  while (true) {

    if (keypressed()) {
      k=readkey();

      if (CI<0) {
        if (mouse_in()) {
          switch(k>>8) {
            case KEY_INSERT: insert_column(TILE_X);
            Case KEY_DEL:    delete_column(TILE_X);
            Case KEY_HOME:   insert_row   (TILE_Y);
            Case KEY_END:    delete_row   (TILE_Y);
          }
        }
        switch(k>>8) {
          case KEY_MINUS:  CT--;
          Case KEY_EQUALS: CT++;
          Case KEY_PGUP:   CT-=16;
          Case KEY_PGDN:   CT+=16;
          Case KEY_UP:     OY-=16*scale;
          Case KEY_DOWN:   OY+=16*scale;
          Case KEY_LEFT:   OX-=16*scale;
          Case KEY_RIGHT:  OX+=16*scale;

          Case KEY_Z: set_scale(1);
          Case KEY_A: set_scale(2);
          Case KEY_Q: set_scale(4);

          Case KEY_P:
            if (!maped_palette_view) {
              maped_palette_view=true;
              old_ox=OX; old_oy=OY;
              OX=-30; OY=0;
            }
          Case KEY_O:
            maped_internal_view=false;
            if (maped_palette_view) {
              maped_palette_view=false;
              OX=old_ox; OY=old_oy;
            }
            for (tx=0; tx<map.w; tx++)
              for (ty=0; ty<map.h; ty++)
                calc_tile(tx,ty);
          Case KEY_I:
            maped_internal_view=true;
            if (maped_palette_view) {
              maped_palette_view=false;
              OX=old_ox; OY=old_oy;
            }

          Case KEY_OPENBRACE: if (mouse_in()) { selL=TILE_X; selU=TILE_Y; selON=true; }
          Case KEY_CLOSEBRACE: if (mouse_in()) { selR=TILE_X; selD=TILE_Y; selON=true; }
          Case KEY_SPACE: selON=false;
   
          Case KEY_C: 
            xfrom=selL; xto=selR;  yfrom=selU; yto=selD;
  
            in_bounds(xfrom,xto,yfrom,yto);

            for (tx=xfrom; tx<=xto; tx++)
              for (ty=yfrom; ty<=yto; ty++) {
                sel[tx-xfrom][ty-yfrom] = map.a[tx][ty];
              }
              selW=xto-xfrom; selH=yto-yfrom;

          Case KEY_V: 
            xfrom=TILE_X; xto=TILE_X+selW;
            yfrom=TILE_Y; yto=TILE_Y+selH;
  
            in_bounds(xfrom,xto,yfrom,yto);

            for (tx=xfrom; tx<=xto; tx++)
              for (ty=yfrom; ty<=yto; ty++) {
                 map.a[tx][ty] = sel[tx-xfrom][ty-yfrom]; 
              }
            for (tx=xfrom; tx<=xto; tx++)
              for (ty=yfrom; ty<=yto; ty++)
                calc_tile(tx,ty);

          Case KEY_F1: tile_attr[CT] ^= ATTR_SOLID_TOP;
          Case KEY_F2: tile_attr[CT] ^= ATTR_SOLID_LRB;
          Case KEY_F9: tile_attr[CT] = 0;
        }
      } else {
        if ((k&255) >= '0' && (k&255) <= '9') {
          d=(k&255)-'0';
          map.i[CI].n = map.i[CI].n*10+d;
        }
        switch(k>>8)
        {
          case KEY_BACKSPACE: map.i[CI].n/=10;
          Case KEY_DEL:
            map.n_ins--;
            map.i[CI]=map.i[map.n_ins];
            CI=-1;
          
          Case KEY_UP:     map.i[CI].y-=4;
          Case KEY_DOWN:   map.i[CI].y+=4;
          Case KEY_LEFT:   map.i[CI].x-=4;
          Case KEY_RIGHT:  map.i[CI].x+=4;
        }
      }
      switch(k>>8) {
        case KEY_TAB: CI++; if (CI==map.n_ins) CI=-1;
          else {
            OX=map.i[CI].x-(SCREEN_W/2*scale);
            OY=map.i[CI].y-(SCREEN_H/2*scale);
          }

        Case KEY_K: ADD_INSERTION(40) // token
        Case KEY_F: ADD_INSERTION(20) // flag
        Case KEY_T: ADD_INSERTION(30) // troll
        Case KEY_1: ADD_INSERTION(11) // player
//        Case KEY_2: ADD_INSERTION(12)

        Case KEY_L:
          if(file_select_ex("Load map:",fn1,"map",80,0,0))
            load_map(fn1);
          CI=-1;
        Case KEY_S:
          if(file_select_ex("Save map as:",fn1,"map",80,0,0))
            save_map(fn1);
        Case KEY_ESC:
          show_mouse(NULL);
          return;
      }
    }
    if (maped_palette_view) {
      if (mouse_b & 3) {
        if (TILE_X & ~15 || TILE_Y & ~15) {}
        else CT = TILE_X + TILE_Y*16;
      }
    } else {
      if (mouse_b==1) {
        if (key[KEY_LCONTROL] || key[KEY_RCONTROL]) {
          ADD_INSERTION(0)
        } else {
          if (CI==-1 && mouse_in())
            map.a[TILE_X][TILE_Y] = CT;
        }
      }
      if (mouse_b==2) {
        CI=-1; d=8;
        for (j=0;j<map.n_ins;j++) {
          d1=ABS(mouse_x*scale+OX-map.i[j].x) + ABS(mouse_y*scale+OY-map.i[j].y);
          if (d1<d) {
            d=d1; CI=j;
          }
       }
        if (mouse_in())
          CT=map.a[TILE_X][TILE_Y];
      }
    }
    draw_all();
  }
}
